%{             /* -*- C -*- */
# include "parsecalc.h"

# define LOC_COLUMN(Col)			\
  lloc->last_column += Col

# define LOC_LINE(Line)				\
  lloc->last_line += Line

# define LOC_STEP()				\
  do {						\
    lloc->first_column = lloc->last_column;	\
    lloc->first_line   = lloc->last_line;	\
  } while (0)

# define YY_USER_ACTION				\
  LOC_COLUMN(yyleng);

%}

%option nounput noyywrap nodefault debug

%%
%{
  // Beginning of yylex(), so it's called
  // each time yylex is invoked.
  LOC_STEP();
  yy_flex_debug = !!getenv("SCANNER");
%}
"-"      return MINUS;
"/"      return SLASH;
"+"      return PLUS;
"*"      return STAR;
"("      return LPAREN;
")"      return RPAREN;
[0-9]+   lval->ival = atoi(yytext); return NUM;
"\n"     lloc->last_column = 1; LOC_LINE(1); return EOL;
[ \t]+   LOC_STEP();
.        fprintf (stderr, "unexpected character: %c\n", yytext[0]); exit(1);
%%
